import { ref } from 'vue'
import { defineStore } from 'pinia'
import type { WorkflowRunResult, WorkflowRunResults } from '@/models'
//import { useLocalStorage } from '@vueuse/core'

export const useData = defineStore('data', () => {
  const wfRuns = ref<WorkflowRunResult[]>([])
  const pendingWfRunIds = ref<Set<string>>(new Set<string>())
  //const wfRuns = useLocalStorage<WorkflowRunResults>("wfRuns", {})
  const addRun = (wfRun: WorkflowRunResult) => {
    //wfRuns.value[wfRun.wfRunId] = wfRun
    wfRuns.value.splice(0, 0, wfRun)
    if (wfRun.status === "COMPLETED" || wfRun.status === "FAILED" || wfRun.status === "TIMEOUT") {
        pendingWfRunIds.value.delete(wfRun.wfRunId)
    }
  }

  return { wfRuns, addRun, pendingWfRunIds }
})

// Type definitions
type UseNullStore = ReturnType<typeof defineStore>
type NullStore = ReturnType<UseNullStore>
type _DataStoreType = ReturnType<typeof useData>
export type DataStoreType = Omit<_DataStoreType, keyof NullStore>